# include Test::Unit::Assertions
class IFD_Assertion
  # Assert 2 values
  def self.reg_compare sActual, regValue, isSpecialChar=false
    begin
      if !isSpecialChar
        sActual = sActual.strip
        regValue = regValue.strip.gsub("[", "\\[").gsub("]", "\\]").gsub("(", "\\(").gsub(")", "\\)").gsub(">", "\\>")
      end
    rescue StandardError => myStandardError
      put_log "\n>>> Error: #{myStandardError}"
    end

    # put_log "\nsActual:#{sActual}, regValue:#{regValue}"
    if ((sActual.nil? and regValue.nil?) or (!sActual.nil? and sActual.empty? and !regValue.nil? and regValue.empty?))
      return true
    end

    if ((sActual.nil? and !regValue.nil?) or (!sActual.nil? and regValue.nil?))
      return false
    end

    if (!sActual.nil? and !sActual.empty?)
      sCookActual = sActual.gsub(/\n|\r/, " ")
      if (sCookActual == regValue or (isSpecialChar and sCookActual.include? regValue) or (!isSpecialChar and sCookActual =~ /^.*#{regValue}.*$/))
        return true
      end
    end

    return false
  end

  def self.assert_string_contain(expected, actual)
    unless (actual.to_s).include? (expected.to_s)
      raise ("*** ASSERTION ERROR: \nExpected: #{expected}. \nGot: #{actual}.")
    end
  end

  def self.assert_string_equal(expected, actual)
    if expected.to_s != actual.to_s
      raise ("*** ASSERTION ERROR: \nExpected: #{expected}. \nGot: #{actual}.")
    end
  end
end
